/******************ʼ**************************************/ 
void main(void) 
{
// Initialize System Control:
// PLL, WatchDog, enable Peripheral Clocks 
   InitSysCtrl();
   
//Initialize GPIO
  InitGpio(); 
   //InitEPwm1Gpio();
   //InitEPwm2Gpio();
   //InitEPwm3Gpio();
#if GPIOSETUP

    // This example is a basic pinout
    Gpio_setup();

#endif  //
  
// Clear all interrupts and initialize PIE vector table:
// Disable CPU interrupts
   DINT;
   
// Initialize the PIE control registers to their default state.
// The default state is all PIE interrupts disabled and flags
// are cleared.
   InitPieCtrl();
   
// Disable CPU interrupts and clear all CPU interrupt flags:   
   IER = 0x0000;
   IFR = 0x0000;
   
// Initialize the PIE vector table with pointers to the shell Interrupt
// Service Routines (ISR).
// This will populate the entire table, even if the interrupt
// is not used in this example.  This is useful for debug purposes.
   InitPieVectTable();
   
   EALLOW;  // This is needed to write to EALLOW protected registers
   PieVectTable.EPWM1_INT = &epwm1_timer_isr;
   PieVectTable.EPWM2_INT = &epwm2_timer_isr;
   PieVectTable.EPWM3_INT = &epwm3_timer_isr;
   PieVectTable.EPWM4_INT = &epwm4_timer_isr;
   EDIS;    // This is needed to disable write to EALLOW protected registers
   
   EALLOW;
   SysCtrlRegs.PCLKCR0.bit.TBCLKSYNC = 0;      // Stop all the TB clocks
   EDIS;

// Initialize EPwmTimer
   InitEPwm();

   EALLOW;
   SysCtrlRegs.PCLKCR0.bit.TBCLKSYNC = 1;      // Start all the timers synced
   EDIS;

   
// User specific code, enable interrupts:  
// Enable CPU INT3 which is connected to EPWM1-7 INT:
   IER |= M_INT3;
   
   PieCtrlRegs.PIEIER3.bit.INTx1 = PWM1_INT_ENABLE;      // Enable INT 3.1 in the PIE
   PieCtrlRegs.PIEIER3.bit.INTx2 = PWM2_INT_ENABLE;      // Enable INT 3.2 in the PIE
   PieCtrlRegs.PIEIER3.bit.INTx3 = PWM3_INT_ENABLE;      // Enable INT 3.3 in the PIE
   PieCtrlRegs.PIEIER3.bit.INTx4 = PWM4_INT_ENABLE;      // Enable INT 3.4 in the PIE
                                   
   EINT;   // Enable Global interrupt INTM
   ERTM;   //Enable Global realtime interrupt DBGM
  
   
   
// Wait for epwm_timer interrupt  
   for(;;)
   {
       asm("   NOP");
   }
}
/********************************************************/ 
void Gpio_setup(void)
{
   // Enable PWM1-4 on GPIO0-GPIO7
   EALLOW;
   GpioCtrlRegs.GPAPUD.bit.GPIO0 = 0;   // Enable pullup on GPIO0
   GpioCtrlRegs.GPAPUD.bit.GPIO1 = 0;   // Enable pullup on GPIO1
   GpioCtrlRegs.GPAPUD.bit.GPIO2 = 0;   // Enable pullup on GPIO2
   GpioCtrlRegs.GPAPUD.bit.GPIO3 = 0;   // Enable pullup on GPIO3
   GpioCtrlRegs.GPAPUD.bit.GPIO4 = 0;   // Enable pullup on GPIO4
   GpioCtrlRegs.GPAPUD.bit.GPIO5 = 0;   // Enable pullup on GPIO5
   GpioCtrlRegs.GPAPUD.bit.GPIO6 = 0;   // Enable pullup on GPIO6
   GpioCtrlRegs.GPAPUD.bit.GPIO7 = 0;   // Enable pullup on GPIO7
   GpioCtrlRegs.GPAMUX1.bit.GPIO0 = 1;  // GPIO0 = PWM1A
   GpioCtrlRegs.GPAMUX1.bit.GPIO1 = 1;  // GPIO1 = PWM1B
   GpioCtrlRegs.GPAMUX1.bit.GPIO2 = 1;  // GPIO2 = PWM2A
   GpioCtrlRegs.GPAMUX1.bit.GPIO3 = 1;  // GPIO3 = PWM2B
   GpioCtrlRegs.GPAMUX1.bit.GPIO4 = 1;  // GPIO4 = PWM3A
   GpioCtrlRegs.GPAMUX1.bit.GPIO5 = 1;  // GPIO5 = PWM3B
   GpioCtrlRegs.GPAMUX1.bit.GPIO6 = 1;  // GPIO6 = PWM4A
   GpioCtrlRegs.GPAMUX1.bit.GPIO7 = 1;  // GPIO7 = PWM4B
   EDIS;
}


void InitEPwm()
{ 
// EPWM1 config
   EPwm1Regs.TBPRD = 1500; // زPeriod = 2*1500TBCLK
   EPwm1Regs.TBPHS.half.TBPHS = 0; // λĴ
   EPwm1Regs.TBCTR = 0x0000;         //ʱ
   EPwm1Regs.TBCTL.bit.CTRMODE = TB_COUNT_UPDOWN; // ʱӼģʽ  Symmetrical mode
   EPwm1Regs.TBCTL.bit.PHSEN = TB_DISABLE;       // ֹλװ
   EPwm1Regs.TBCTL.bit.PRDLD = TB_SHADOW;        //ĬӰģʽ
   EPwm1Regs.TBCTL.bit.SYNCOSEL = TB_CTR_ZERO; // TBCTR=0ʱͬ¼
   EPwm1Regs.TBCTL.bit.CLKDIV = TB_DIV1;   // TBCLK=SYSCLKOUT/(HSPCLKDIV*CLKDIV)=60M/(1*1)=60M
   EPwm1Regs.TBCTL.bit.HSPCLKDIV = TB_DIV1;
   EPwm1Regs.CMPCTL.bit.SHDWAMODE = CC_SHADOW;
   EPwm1Regs.CMPCTL.bit.SHDWBMODE = CC_SHADOW;
   EPwm1Regs.CMPCTL.bit.LOADAMODE = CC_CTR_ZERO; // load on CTR=Zero
   EPwm1Regs.CMPCTL.bit.LOADBMODE = CC_CTR_ZERO; // load on CTR=Zero
   EPwm1Regs.AQCTLA.bit.CAU = AQ_CLEAR; // set actions for EPWM1A
   EPwm1Regs.AQCTLA.bit.CAD = AQ_SET;
   
   EPwm1Regs.DBCTL.bit.OUT_MODE = DB_FULL_ENABLE; // enable Dead-band module
   EPwm1Regs.DBCTL.bit.POLSEL = DB_ACTV_HIC; // Active Hi complementary
   EPwm1Regs.DBFED = 120; // FED = 120 TBCLKs
   EPwm1Regs.DBRED = 120; // RED = 120 TBCLKs
   
   //  Initialize the ePWM1 registers that related to interrupt 
   EPwm1Regs.ETSEL.bit.INTSEL = 1;        //TBCTR = 0x0000  ж
   EPwm1Regs.ETSEL.bit.INTEN = 1;         //enable interrupt
   EPwm1Regs.ETPS.bit.INTPRD = 3;         //Genterate an interrupt on 3rd event
   
   
// EPWM2 config
   EPwm2Regs.TBPRD = 1500; // زPeriod = 2*1500TBCLK
   EPwm2Regs.TBPHS.half.TBPHS = 0; // λĴ
   EPwm2Regs.TBCTR = 0x0000;         //ʱ
   EPwm2Regs.TBCTL.bit.CTRMODE = TB_COUNT_UPDOWN; // ʱӼģʽ  Symmetrical mode
   EPwm2Regs.TBCTL.bit.PHSEN = TB_ENABLE; // λװ
//EPwm2Regs.TBCTL.bit.PHSDIR=0x1;    // Count up after the synchronization event
   EPwm2Regs.TBCTL.bit.PRDLD = TB_SHADOW;        //ĬӰģʽ
   EPwm2Regs.TBCTL.bit.SYNCOSEL = TB_SYNC_IN;// sync flow-through
   EPwm2Regs.TBCTL.bit.CLKDIV = TB_DIV1;   // TBCLK=SYSCLKOUT/(HSPCLKDIV*CLKDIV)=60M/(1*1)=60M
   EPwm2Regs.TBCTL.bit.HSPCLKDIV = TB_DIV1;
   EPwm2Regs.CMPCTL.bit.SHDWAMODE = CC_SHADOW;
   EPwm2Regs.CMPCTL.bit.SHDWBMODE = CC_SHADOW;
   EPwm2Regs.CMPCTL.bit.LOADAMODE = CC_CTR_ZERO; // load on CTR=Zero
   EPwm2Regs.CMPCTL.bit.LOADBMODE = CC_CTR_ZERO; // load on CTR=Zero
   EPwm2Regs.AQCTLA.bit.CAU = AQ_CLEAR; // set actions for EPWM2A
   EPwm2Regs.AQCTLA.bit.CAD = AQ_SET;
   
   EPwm2Regs.DBCTL.bit.OUT_MODE = DB_FULL_ENABLE; // enable Dead-band module
   EPwm2Regs.DBCTL.bit.POLSEL = DB_ACTV_HIC; // Active Hi complementary
   EPwm2Regs.DBFED = 120; // FED = 120 TBCLKs
   EPwm2Regs.DBRED = 120; // RED = 120 TBCLKs
   
   //  Initialize the ePWM2 registers that related to interrupt 
   EPwm2Regs.ETSEL.bit.INTSEL = 1;        //TBCTR = 0x0000  ж
   EPwm2Regs.ETSEL.bit.INTEN = 1;         //enable interrupt
   EPwm2Regs.ETPS.bit.INTPRD = 3;         //Genterate an interrupt on 3rd event
   

// EPWM3 config
   EPwm3Regs.TBPRD = 1500; // زPeriod = 2*1500TBCLK
   EPwm3Regs.TBPHS.half.TBPHS = 0; // Set Phase register to zero
   EPwm3Regs.TBCTR = 0x0000;         //ʱ
   EPwm3Regs.TBCTL.bit.CTRMODE = TB_COUNT_UPDOWN; // ʱӼģʽ  Symmetrical mode
   EPwm3Regs.TBCTL.bit.PHSEN = TB_ENABLE; // λװ
   //EPwm3Regs.TBCTL.bit.PHSDIR=0x1;    // Count up after the synchronization event
   EPwm3Regs.TBCTL.bit.PRDLD = TB_SHADOW;
   EPwm3Regs.TBCTL.bit.SYNCOSEL =TB_SYNC_IN; // sync flow-through
   EPwm3Regs.TBCTL.bit.CLKDIV = TB_DIV1;   // ʱƵ  TBCLK=SYSCLKOUT/(HSPCLKDIV*CLKDIV)=60M/(1*1)=60M
   EPwm3Regs.TBCTL.bit.HSPCLKDIV = TB_DIV1;
   EPwm3Regs.CMPCTL.bit.SHDWAMODE = CC_SHADOW;
   EPwm3Regs.CMPCTL.bit.SHDWBMODE = CC_SHADOW;
   EPwm3Regs.CMPCTL.bit.LOADAMODE = CC_CTR_ZERO; // load on CTR=Zero
   EPwm3Regs.CMPCTL.bit.LOADBMODE = CC_CTR_ZERO; // load on CTR=Zero
   EPwm3Regs.AQCTLA.bit.CAU = AQ_SET; // set actions for EPWM3A
   EPwm3Regs.AQCTLA.bit.CAD = AQ_CLEAR;
   
   EPwm3Regs.DBCTL.bit.OUT_MODE = DB_FULL_ENABLE; // enable Dead-band module
   EPwm3Regs.DBCTL.bit.POLSEL = DB_ACTV_HIC; // Active Hi complementary
   EPwm3Regs.DBFED = 120; // FED = 120 TBCLKs
   EPwm3Regs.DBRED = 120; // RED = 120 TBCLKs
   
   
   //  Initialize the ePWM3 registers that related to interrupt 
   EPwm3Regs.ETSEL.bit.INTSEL = 1;        //TBCTR = 0x0000 ж
   EPwm3Regs.ETSEL.bit.INTEN = 1;         //enable interrupt
   EPwm3Regs.ETPS.bit.INTPRD = 3;         //Genterate an interrupt on 3rd event
   

// EPWM4 config
   EPwm4Regs.TBPRD = 1500; // زPeriod = 2*1500TBCLK
   EPwm4Regs.TBPHS.half.TBPHS = 0; // Set Phase register to zero
   EPwm4Regs.TBCTR = 0x0000;         //ʱ
   EPwm4Regs.TBCTL.bit.CTRMODE = TB_COUNT_UPDOWN; // ʱӼģʽ  Symmetrical mode
   EPwm4Regs.TBCTL.bit.PHSEN = TB_ENABLE; // λװ
   //EPwm4Regs.TBCTL.bit.PHSDIR=0x1;    // Count up after the synchronization event
   EPwm4Regs.TBCTL.bit.PRDLD = TB_SHADOW;
   EPwm4Regs.TBCTL.bit.SYNCOSEL =TB_SYNC_IN;  // TB_SYNC_IN;  sync flow-through
   EPwm4Regs.TBCTL.bit.CLKDIV = TB_DIV1;   // ʱƵ  TBCLK=SYSCLKOUT/(HSPCLKDIV*CLKDIV)=60M/(1*1)=60M
   EPwm4Regs.TBCTL.bit.HSPCLKDIV = TB_DIV1;
   EPwm4Regs.CMPCTL.bit.SHDWAMODE = CC_SHADOW;
   EPwm4Regs.CMPCTL.bit.SHDWBMODE = CC_SHADOW;
   EPwm4Regs.CMPCTL.bit.LOADAMODE = CC_CTR_ZERO; // load on CTR=Zero
   EPwm4Regs.CMPCTL.bit.LOADBMODE = CC_CTR_ZERO; // load on CTR=Zero
   EPwm4Regs.AQCTLA.bit.CAU = AQ_SET;   // set actions for EPWM4A
   EPwm4Regs.AQCTLA.bit.CAD = AQ_CLEAR;
   EPwm4Regs.AQCTLB.bit.CBU = AQ_CLEAR; //AQ_CLEAR;// set actions for EPWM4B
   EPwm4Regs.AQCTLB.bit.CBD = AQ_SET;// AQ_SET;
   
   //EPwm4Regs.DBCTL.bit.OUT_MODE = DB_FULL_ENABLE; // enable Dead-band module
   //EPwm4Regs.DBCTL.bit.POLSEL = DB_ACTV_HIC; // Active Hi complementary
   //EPwm4Regs.DBFED = 120; // FED = 120 TBCLKs
   //EPwm4Regs.DBRED = 120; // RED = 120 TBCLKs
   
   //  Initialize the ePWM4 registers that related to interrupt 
   EPwm4Regs.ETSEL.bit.INTSEL = 1;        //TBCTR = 0x0000 ж
   EPwm4Regs.ETSEL.bit.INTEN = 1;         //enable interrupt
   EPwm4Regs.ETPS.bit.INTPRD = 3;         //Genterate an interrupt on 3rd event
}